 '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 '-----------------------------------------------------------------
 '                      C O M B C H E C K 4
 '-----------------------------------------------------------------
 ' Looking inside the combinations of random numbers generated
 ' with a previous program [RandGen3.bas].
 ' In this program we count the repetitions of single numbers
 ' and display them.
 ' Input:  Video Format CombCheck4.scn
 '         file  RandGen.dat
 ' Processing: Counting the number of hits of the single numbers.
 '         The Screen Format is converted for displayng in a WIN
 '         Console Box from a DOS Screen Format.
 ' Output: Display the results on a Screen Format [CombCheck4.scn]
 '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 ' Date: 26-apr-2010 / release 0.1
 ' Language: PB/CC 5.04
 ' Authors: frktons and MASM Forum guys
 '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


 #INCLUDE "win32api.inc"




 DECLARE SUB ReadForm(BYVAL location AS LONG, BYVAL Name_Screen AS STRING)

 DECLARE SUB DisplayScreen

 DECLARE SUB ConvertASM
 DECLARE SUB ReadRandFile
 DECLARE SUB CountNumbers
 DECLARE SUB DisplayResults
 DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () AS DWORD

 GLOBAL n&(), g&(), numbers&()

 TYPE RandDataRec
     Num(1 TO 6400) AS LONG
 END TYPE


 FUNCTION PBMAIN()

   GLOBAL FormName AS STRING
   FormName = "CombCheck4"

   GLOBAL MainStr AS STRING, sBuf AS STRING
   GLOBAL location AS LONG
   GLOBAL x,x1,x2,x3,x4,x5,x6,y,y1,y2,y3,y4,y5,y6, n_idx AS LONG
   DIM numbers&(1 TO 50)

   FOR x = 1 TO 50
       numbers&(x) = 0
   NEXT x

   LOCAL tc AS DWORD

   DIM n&(1 TO 320000)

   GLOBAL ok, si, no AS LONG, first AS LONG, last AS LONG
   GLOBAL rows AS LONG
   GLOBAL cols AS LONG

   last = 5000
   first = 1


   tc = GetTickCount
   TIX cycles&&

   CALL ReadForm(1, FormName)
   CALL ConvertASM

   CALL ReadRandFile

   CONSOLE SCREEN 25,80

   CURSOR OFF

   CALL DisplayScreen

   CALL CountNumbers

   COLOR 7,0

   CALL DisplayResults


   TIX END cycles&&
   tc = GetTickCount - tc

   LOCATE 18,28
   PRINT FORMAT$(tc,"###,###");

   LOCATE 20,22
   PRINT FORMAT$(cycles&&,"###,");




 exit_pgm:



'   LOCATE 8,66
'   PRINT TIME$

   WAITKEY$

 END FUNCTION



'--------------------------------------------------------------------------------
' Convert the DOS screen into WIN Console screen - ASM version
'--------------------------------------------------------------------------------
 SUB ConvertASM

    #REGISTER NONE

    ! push ebx
    ! push esi
    ! push edi
    ! push eax

    sBuf = SPACE$(8000)

       ! mov ebx, 1000
       ! mov esi, MainStr
       ! mov edi, sBuf
       Convert:
       ! mov eax, [esi]
       ! mov [edi], al
       ! mov [edi+2], ah
       ! bswap eax
       ! mov [edi+6], al
       ! mov [edi+4], ah
       ! add esi, 4
       ! add edi, 8
       ! dec ebx
       ! jnz Convert

    ! pop eax
    ! pop edi
    ! pop esi
    ! pop ebx

  END SUB

'--------------------------------------------------------------------------------
' Display the converted Screen
'--------------------------------------------------------------------------------

 SUB DisplayScreen

    LOCAL lpReadRegion AS SMALL_RECT
    LOCAL SIZE AS DWORD
    SIZE = MAKDWD(80, 25)

    lpReadRegion.xRight = 79
    lpReadRegion.xBottom = 24
    WriteConsoleOutPut GetStdHandle(%STD_OUTPUT_HANDLE), _
    BYVAL STRPTR(sBuf),BYVAL SIZE, BYVAL 0&, lpReadRegion
 END SUB

'--------------------------------------------------------------------------------
' Read the DOS screen into the variabile MainStr
'--------------------------------------------------------------------------------

 SUB ReadForm(BYVAL location AS LONG, BYVAL ScreenName AS STRING)
    LOCAL ff AS LONG

    ff = FREEFILE
    OPEN ScreenName + ".scn" FOR BINARY AS #ff
      SEEK ff, location
      GET$ #ff, 4000, MainStr
    CLOSE #ff

 END SUB

'--------------------------------------------------------------------------------
' Read file RandGen.dat into an array
'--------------------------------------------------------------------------------

 SUB ReadRandFile

    LOCAL ff AS LONG

    DIM DataRec AS RandDataRec

    n_idx = 1

    ff = FREEFILE
    OPEN "RandGen.dat" FOR RANDOM AS #ff LEN=25600


    FOR x = 1 TO 50
       GET #ff, x, DataRec
       FOR x1 = 1 TO 6400
           n&(n_idx) = DataRec.Num(x1)
           INCR n_idx
       NEXT x1

    NEXT x

    CLOSE #ff

 END SUB

'--------------------------------------------------------------------------------
' Counts the occurrences of the single numbers
'--------------------------------------------------------------------------------

 SUB CountNumbers

    FOR x = 1 TO 320000
        INCR numbers&(n&(x))
    NEXT x

 END SUB

'--------------------------------------------------------------------------------
' Displays the occurrences of the single numbers on Screen Format
'--------------------------------------------------------------------------------

 SUB DisplayResults

    n_idx = 1
    FOR cols = 5 TO 77 STEP 8
        FOR rows = 5 TO 13 STEP 2
            LOCATE rows, cols
            PRINT FORMAT$(numbers&(n_idx), "#");
            INCR n_idx
        NEXT rows
    NEXT cols

 END SUB
